'
' A sqlite3 demo program
'
VERSION "0.0001"
CONSOLE
'
IMPORT "xst"				' Standard library : required by most programs
IMPORT "xsx"				' Extended standard library
IMPORT "sqlite3"

DECLARE FUNCTION Entry ()

FUNCTION Entry ()

' get version of sqlite3 database
  PRINT CSTRING$(sqlite3_libversion())

' get version of sqlite3 database using SQL query

' open a new database connection
' :memory: is a special database name which uses in in-memory database

  rc = sqlite3_open(&":memory:", &db)

  IF (rc != $$SQLITE_OK) THEN

    PRINT "Cannot open database: "; CSTRING$(sqlite3_errmsg(db))
    sqlite3_close(db)

    GOTO end
  END IF

' prepare SQL statement, get precompiled statement handle res

  rc = sqlite3_prepare_v2(db, &"SELECT SQLITE_VERSION()", -1, &res, 0)

  IF (rc != $$SQLITE_OK) THEN

    PRINT "Failed to fetch data: "; CSTRING$(sqlite3_errmsg(db))
    sqlite3_close(db)

    GOTO end
  END IF

' run SQL statement using res
  rc = sqlite3_step(res)

' get first row + column of data
  IF (rc == $$SQLITE_ROW) THEN
    PRINT CSTRING$(sqlite3_column_text(res, 0))
  END IF

' destroy statement object res
  sqlite3_finalize(res)

' close database connection
  sqlite3_close(db)

end:

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM