' 
PROGRAM	"demo4"
VERSION "0.0001"
CONSOLE
' 
IMPORT "xst"		' Standard library : required by most programs
IMPORT "xsx"		' Extended standard library
IMPORT "sqlite3"

DECLARE FUNCTION Entry ()
DECLARE CFUNCTION callback (void, argc, rowData, colName)

$$DIVIDER$ = "====================================================="

FUNCTION Entry ()

	' Open the database
	rc = sqlite3_open (&"Chinook_Sqlite.sqlite", &db)
	IF rc <> $$SQLITE_OK THEN
		PRINT "Cannot open database: "; CSTRING$ (sqlite3_errmsg (db))		'fprintf(stderr, "Cannot open database: %s\n", sqlite3_errmsg(db));
		sqlite3_close (db)
		RETURN ($$TRUE)
	END IF
	
	' sqlite_master: This built-in table in SQLite is used to get information
	' about all tables in the database, including their names and structure
	sql$ = "SELECT * FROM sqlite_master WHERE type='table';"

	' Execute query to get table names
	IF (sqlite3_exec (db, &sql$, &callback (), NULL, &errorMessage) <> $$SQLITE_OK) THEN
		PRINT "Error executing query: "; CSTRING$ (errorMessage)		' (Error executing query: %s\n", errorMessage)
		sqlite3_free (errorMessage)
		sqlite3_close (db)
		GOTO end
	ELSE
		PRINT "Opened database successfully."
	END IF
	
	PRINT $$DIVIDER$
	
	' SELECT all from Album table
		
	sql$ = "SELECT * FROM Album"

	' Execute query to get table names
	rc = sqlite3_exec (db, &sql$, &callback (), NULL, &errorMessage)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; CSTRING$ (errorMessage)
		sqlite3_free (errorMessage)
		GOTO end
	ELSE
		PRINT "SELECT * FROM Album successful"
	END IF

	PRINT $$DIVIDER$
	
	' get Artist table
		
	sql$ = "SELECT * FROM Artist"

	' Execute query to get table names
	rc = sqlite3_exec (db, &sql$, &callback (), NULL, &errorMessage)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; CSTRING$ (errorMessage)
		sqlite3_free (errorMessage)
		GOTO end
	ELSE
		PRINT "SELECT * FROM Artist successful"
	END IF

	PRINT $$DIVIDER$
	
	' now do a JOIN selection since the two tables have a common column ArtistId
	
	sql$ = "SELECT Album.Title, Artist.Name FROM Album LEFT OUTER JOIN Artist ON Album.ArtistId = Artist.ArtistId"
	' Execute query to get table names
	rc = sqlite3_exec (db, &sql$, &callback (), NULL, &errorMessage)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; CSTRING$ (errorMessage)
		sqlite3_free (errorMessage)
		GOTO end
	ELSE
		PRINT "SELECT ... FROM ... LEFT OUTER JOIN successful"
	END IF
	
	PRINT $$DIVIDER$
		
	' use WHERE to select specific items in column ArtistId

	sql$ = "SELECT Album.Title, Artist.Name FROM Album LEFT OUTER JOIN Artist ON Album.ArtistId = Artist.ArtistId WHERE Artist.Name = 'Amy Winehouse' OR Artist.Name ='Nirvana'"
	' Execute query to get table names
	rc = sqlite3_exec (db, &sql$, &callback (), NULL, &errorMessage)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; CSTRING$ (errorMessage)
		sqlite3_free (errorMessage)
		GOTO end
	ELSE
		PRINT "SELECT ... FROM ... LEFT OUTER JOIN ... WHERE successful"
	END IF

end:
	sqlite3_close (db)

	a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

CFUNCTION callback (void, argc, pRowData, pColName)

	FOR i = 0 TO argc - 1
		colNames$ = CSTRING$ (XLONGAT (pColName + i * 4))
		data$ = CSTRING$ (XLONGAT (pRowData + i * 4))
		IFZ data$ THEN data$ = "NULL"
		PRINT colNames$ + " = " + data$
	NEXT i

END FUNCTION
END PROGRAM