'
' ####################
' #####  PROLOG  #####
' ####################
'
' sqlite3 example with callback function
'
VERSION "0.0001"

PROGRAM "demo5"
CONSOLE

IMPORT "xst_s.lib"
IMPORT "xsx_s.lib"
IMPORT "sqlite3"

DECLARE FUNCTION Entry ()
DECLARE CFUNCTION MyCallback (hwnd, nCols, ppValue, ppColName)
DECLARE FUNCTION GetError (db)

FUNCTION Entry ()

	DIM args[0]
	args[0] = 0
	pVersion = sqlite3_libversion ()
	PRINT "sqlite3 version: "; CSTRING$ (pVersion)

	db$ = "test0.db"

	' check if test0.db exists
	IFZ XstFileExists (db$) THEN XstDeleteFile (db$)

	' create new database file
	rc = sqlite3_open (&db$, &dbHandle)
	IF (rc <> $$SQLITE_OK) THEN GetError (dbHandle)
	
	sql$ = "CREATE TABLE IF NOT EXISTS test (Item varchar primary key, Color text, Price real)"
	rc = sqlite3_exec (dbHandle, &sql$, 0, 0, 0)
	IF (rc <> $$SQLITE_OK) THEN GetError (dbHandle)

	sql$ = "INSERT INTO test VALUES ('apple1a','green',0.95),('apple2a','red',0.55),('apple3a','yellow',0.45),('apple4a','red',0.75),('apple5a','green',0.45),('apple6a','red',0.85),('apple7a','yellow',0.95),('apple8a','red',0.55),('apple9a','green',0.65)"
	rc = sqlite3_exec (dbHandle, &sql$, 0, 0, 0)
	IF (rc <> $$SQLITE_OK) THEN GetError (dbHandle)

	sql$ = "SELECT * FROM test WHERE color = 'red'"
	rc = sqlite3_exec (dbHandle, &sql$, &MyCallback(), 0, 0)
	IF (rc <> $$SQLITE_OK) THEN GetError (dbHandle)
	
	sqlite3_close (dbHandle)

	a$ = INLINE$ ("Press any key to quit > ")

END FUNCTION

CFUNCTION MyCallback (dbHandle, nCols, ppValue, ppColName)
	
	IFZ nCols THEN RETURN 1
	
	FOR i = 0 TO nCols-1
		
		' get column name
		pColName = XLONGAT(ppColName + (i*4))
		colName$ = CSTRING$(pColName)	
		? colName$; ": ";
		
		' get value in column
		pValue = XLONGAT(ppValue + (i*4))
		value$ = CSTRING$(pValue)
		? value$
	NEXT i

END FUNCTION

FUNCTION GetError (db)

	sqlite3_close (db)

	DIM args[0]
	args[0] = db
	errcode = sqlite3_errcode (db)
	pMsg = sqlite3_errmsg(db)
	IF pMsg THEN errormsg$ = CSTRING$ (pMsg)
	sqlite3_free (err_msg)

	errorstr$ = "SQL error: " + errormsg$ + "\r\nerror : " + STRING (errcode)
	XstAbend (@errorstr$)
	QUIT (errcode)

END FUNCTION

END PROGRAM