'
' ####################
' #####  PROLOG  #####
' ####################
'
' sqlite3 example using sqlite3_exec, sqlite3_prepare_v2, and sqlite3_step
'
VERSION "0.0001"
CONSOLE
'
'	IMPORT "xst"				' Standard library : required by most programs
'	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

	IMPORT "xst_s.lib"
  IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

  IMPORT "sqlite3"
'
DECLARE FUNCTION Entry ()
' 
' 
' ######################
' #####  Entry ()  #####
' ######################
' 
FUNCTION Entry ()

	DOUBLE price

	' Open database
	rc = sqlite3_open (&"test1.db", &db)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "Cannot open database: "; sqlite3_errmsg (db)
		err = 1
		GOTO getout
	END IF

	' Create table
	sql$ = "CREATE TABLE IF NOT EXISTS Cars(Id INT, Name TEXT, Price REAL)"
	rc = sqlite3_exec (db, &sql$, 0, 0, &err_msg)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; err_msg
		sqlite3_free (err_msg)
		err = 1
		GOTO getout
	END IF

	' Insert data
	sql$ = "INSERT INTO Cars VALUES(1, 'Audi', 52642),(2, 'Honda CR-V', 35500),(3, 'BMW 3 Series', 58700)"
	rc = sqlite3_exec (db, &sql$, 0, 0, &err_msg)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; err_msg
		sqlite3_free (err_msg)
		err = 1
		GOTO getout
	END IF

	' Select all data
	sql$ = "SELECT * FROM Cars "
	stmt = 0
	rc = sqlite3_prepare_v2 (db, &sql$, -1, &stmt, 0)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; sqlite3_errmsg (db)
		err = 1
		GOTO getout
	END IF

	DO WHILE (sqlite3_step (stmt) == $$SQLITE_ROW)
		id = sqlite3_column_int (stmt, 0)
		pname = sqlite3_column_text (stmt, 1)
		name$ = CSTRING$ (pname)
		price = sqlite3_column_double (stmt, 2)
		PRINT "ID: "; id, "Name: "; name$, "Price: "; FORMAT$ ("##,###.##", price)
	LOOP
		
	sqlite3_finalize (stmt)
		
	' Select certain data based on criteria
	sql$ = "SELECT * FROM Cars WHERE Price > 50000"
	stmt = 0
	rc = sqlite3_prepare_v2 (db, &sql$, -1, &stmt, 0)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; sqlite3_errmsg (db)
		err = 1
		GOTO getout
	END IF

	DO WHILE (sqlite3_step (stmt) == $$SQLITE_ROW)
		id = sqlite3_column_int (stmt, 0)
		pname = sqlite3_column_text (stmt, 1)
		name$ = CSTRING$ (pname)
		price = sqlite3_column_double (stmt, 2)
		PRINT "ID: "; id, "Name: "; name$, "Price: "; FORMAT$ ("##,###.##", price)
	LOOP
		
	sqlite3_finalize (stmt)
	
	' Select Name column based on sorting by Price
	sql$ = "SELECT Name FROM Cars ORDER BY Price"
	stmt = 0
	rc = sqlite3_prepare_v2 (db, &sql$, -1, &stmt, 0)
	IF (rc <> $$SQLITE_OK) THEN
		PRINT "SQL error: "; sqlite3_errmsg (db)
		err = 1
		GOTO getout
	END IF

	DO WHILE (sqlite3_step (stmt) == $$SQLITE_ROW)
		pname = sqlite3_column_text (stmt, 0)
		name$ = CSTRING$ (pname)
		PRINT "Name: "; name$
	LOOP
		
	sqlite3_finalize (stmt)
	
getout:
	sqlite3_close (db)
		
	error = XstDeleteFile ("test1.db")

	a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION err
END PROGRAM